﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WindowsApplication1.Cakra;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        #region コンストラクタ
        public Form1()
        {
            InitializeComponent();
        }
        #endregion
        
        #region イベント
        
        /// <summary>
        /// ただの螺旋丸
        /// </summary>
        private void button1_Click(object sender, EventArgs e)
        {
            this.GetNaruto().Rasengan();            
        }

        /// <summary>
        /// 影分身して螺旋丸
        /// </summary>
        private void button2_Click(object sender, EventArgs e)
        {
            Naruto copyNaruto = this.GetNaruto().ShadowCopy();
            copyNaruto.Rasengan();
        }

        /// <summary>
        /// 影分身したあとに、さらに影分身をして螺旋丸
        /// </summary>
        private void button1_Click_1(object sender, EventArgs e)
        {
            Naruto copyNaruto = this.GetNaruto().ShadowCopy().ShadowCopy();
            copyNaruto.Rasengan();
        }

        /// <summary>
        /// 口寄せの術でガマ親分を呼ぶ
        /// </summary>
        private void btnKutiyose_Click(object sender, EventArgs e)
        {
            Naruto naruto =  this.GetNaruto();
            Gamaoyabin gama = naruto.Kutiyose();
            gama.Vice();
        }

        /// <summary>
        /// ナルトがしゃべるってばよ
        /// </summary>
        private void btnVoice_Click(object sender, EventArgs e)
        {
            Naruto naruto = this.GetNaruto();
            string msg = textBox1.Text;
            MessageBox.Show(naruto.Voice(msg));
        }

        /// <summary>
        /// 指定回数影分身をして、影分身の総数を取得
        /// </summary>
        private void button2_Click_1(object sender, EventArgs e)
        {
            Naruto naruto = this.GetNaruto();
            for (int i = 0;i < (int)this.numericUpDown1.Value;i++){
                //影分身の術
                naruto.ShadowCopy();
            }
            MessageBox.Show("ナルトの影分身の総数は、" + Convert.ToString(naruto.GetCopyCount) + "人だってばよ。");
        }

        /// <summary>
        /// 風のチャクラを練る1
        /// </summary>
        private void btnCakra_Click(object sender, EventArgs e){
            try{
                ICakra cakra = this.GetNaruto().KazeCakura1();
                MessageBox.Show(cakra.CakraName); 
            }
            catch (Exception ex){
                MessageBox.Show(ex.Message);
                MessageBox.Show("インターフェイスはインスタンス化できないため、NullObjectを生成できませんでした。");
            }        
        }

        /// <summary>
        /// 風のチャクラを練る2
        /// </summary>
        private void btnCakra2_Click(object sender, EventArgs e){
            try{
                AbstractCakra cakra = this.GetNaruto().KazeCakra2();
                MessageBox.Show(cakra.CakraName);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                MessageBox.Show("抽象クラスはインスタンス化できないため、NullObjectを生成できませんでした。");
            }        
        }

        /// <summary>
        /// 九尾のチャクラを練る1
        /// </summary>
        private void btnCakra3_Click(object sender, EventArgs e){
            Kyubi cakra ;
            this.GetNaruto().KyubiCakra1(out cakra);
            MessageBox.Show(cakra.CakraName);
        }

        /// <summary>
        /// 九尾のチャクラを練る2
        /// </summary>
        private void btnCakra4_Click(object sender, EventArgs e)
        {
            Kyubi cakra = null;
            this.GetNaruto().KyubiCakra2(ref cakra);
            MessageBox.Show(cakra.CakraName);
        }
        
        #endregion

        #region メソッド
        private Naruto GetNaruto()
        {
            if (this.rdoNaruto.Checked)
            {
                //ナルトの実態を返す
                return new Naruto();
            }

            //NullObjectなナルトを返す
            return NullProxy<Naruto>.GetInstance();
        }
        #endregion
    }
}